from typing import AsyncIterable

from v6d3music.core.create_ytaudios import create_ytaudios
from v6d3music.core.entries_effects_for_args import entries_effects_for_args
from v6d3music.core.ytaudio import YTAudio
from v6d3music.utils.argctx import InfoCtx

from v6d2ctx.context import Context


async def yt_audios(ctx: Context, args: list[str]) -> AsyncIterable[YTAudio]:
    tuples: list[InfoCtx] = []
    assert ctx.guild is not None
    async for it in entries_effects_for_args(args, ctx.guild.id):
        tuples.append(it)
        if len(tuples) >= 5:
            async for audio in create_ytaudios(ctx, tuples):
                yield audio
            tuples.clear()
    async for audio in create_ytaudios(ctx, tuples):
        yield audio
